package com.zehfernando.ld27.application {
	import com.zehfernando.display.templates.application.SimpleApplication;
	import com.zehfernando.input.binding.KeyActionBinder;
	import com.zehfernando.ld27.display.Main;
	import com.zehfernando.localization.StringResources;
	import com.zehfernando.net.assets.AssetLibrary;
	import com.zehfernando.utils.AppUtils;

	import flash.display.StageDisplayState;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.DropShadowFilter;
	/**
	 * @author zeh fernando
	 */
	public class LD27 extends SimpleApplication {

		// Constants
		public static const TARGET_FPS:Number = 60;

		public static const ASSET_NAME_JSON_GAME:String = "game_json";

		public static const DENSITY_SCALE:Number = 1;
		public static const FONT_SCALE:Number = 1;
		public static const STACKED_FONT_SCALE:Number = DENSITY_SCALE * FONT_SCALE;

		public static const FILTER_DROP_SHADOW:DropShadowFilter = new DropShadowFilter(3, 45, 0x000000, 0.5, 6, 6);

		// Platform constants
		public static const PLATFORM_ALIASING_LEVEL:int = 0; // AppUtils.isAndroid() ? 0 : 8;

		// Debug
		public static const DEBUG_SHOW_STATS_BIG:Boolean										= AppUtils.isDebugSWF() && false;	// Shows Flash statistics (mine)
		public static const DEBUG_SHOW_STATS_STARLING:Boolean									= AppUtils.isDebugSWF() && true;	// Shows rendering statistics (Starling)
		public static const DEBUG_DRAW_DEBUG_BODIES_LAYER:Boolean								= AppUtils.isDebugSWF() && false;	// Draws debug bodies containers at all? (this overrides the parameter below)
		public static const DEBUG_DRAW_ALL_DEBUG_BODIES:Boolean									= AppUtils.isDebugSWF() && false;	// Draws all physics bodies, including of actors that already have sprites
		public static const DEBUG_DRAW_SPRITE_BOUNDS:Boolean									= AppUtils.isDebugSWF() && false;	// Adds a tinting to all sprite bitmaps, to visualize its rectangle
		public static const DEBUG_GAME_IGNORE_EMPTY_FUEL:Boolean								= AppUtils.isDebugSWF() && false;	// Never runs out of fuel
		public static const DEBUG_SKIP_SCENE_TRANSITIONS:Boolean								= AppUtils.isDebugSWF() && false;	// Doesn't show fades when switching between scenes

		// Other properties
		public static var gameInfo:Object;
		public static var strings:StringResources;

		// Instances
		private var main:Main;

		// ================================================================================================================
		// CONSTRUCTOR ----------------------------------------------------------------------------------------------------

		public function LD27() {
			super();

			// Do not add anything else here

			// This is due to the bug on Adobe AIR GameInput (forces instantiation of listener on first frame)
			KeyActionBinder;
		}

		// ================================================================================================================
		// INTERNAL INTERFACE ---------------------------------------------------------------------------------------------

		override protected function addDynamicAssetsFirstPass():void {
			addDynamicAsset("data/game.json", ASSET_NAME_JSON_GAME);
		}

		override protected function createVisualAssets():void {
			// Initializations
			gameInfo = AssetLibrary.getLibrary().getJSON(ASSET_NAME_JSON_GAME);

			main = new Main();
			addChild(main);
			main.init();
		}

		override protected function redrawVisualAssets():void {
			main.width = stage.stageWidth;
			main.height = stage.stageHeight;
		}

		override protected function deactivate():void {
			if (main != null) {
				main.deactivate();
			}
		}
	}
}
