package com.zehfernando.ld27.display {
	import com.zehfernando.display.abstracts.ResizableSprite;
	import com.zehfernando.display.debug.statgraph.StatGraph;
	import com.zehfernando.display.scenes.SceneViewer;
	import com.zehfernando.ld27.application.LD27;
	import com.zehfernando.ld27.display.scenes.instructions.InstructionsScene;
	import com.zehfernando.utils.AppUtils;
	import com.zehfernando.utils.console.log;

	import flash.ui.GameInput;

	/**
	 * @author zeh fernando
	 */
	public class Main extends ResizableSprite {

		// Instances
		private var sg:StatGraph;

		private var sceneViewer:SceneViewer;

		private var isInitialized:Boolean;


		// ================================================================================================================
		// CONSTRUCTOR ----------------------------------------------------------------------------------------------------

		public function Main() {
			super();
		}

		// ================================================================================================================
		// INTERNAL INTERFACE ---------------------------------------------------------------------------------------------

		override protected function redrawWidth():void {
			if (isInitialized) {
				sceneViewer.width = _width;
			}
		}

		override protected function redrawHeight():void {
			if (isInitialized) {
				sceneViewer.height = _height;
			}
		}


		// ================================================================================================================
		// PUBLIC INTERFACE -----------------------------------------------------------------------------------------------

		public function init():void {
			isInitialized = true;

			if (LD27.DEBUG_SHOW_STATS_BIG) {
				sg = new StatGraph();
				sg.x = stage.stageWidth - sg.width;
				addChild(sg);
			}

			log("Initialized.");
			log("Size = " + stage.stageWidth + stage.stageHeight);
			log("isAndroid = " + AppUtils.isAndroid());
			log("Gamepads = " + GameInput.numDevices);

			sceneViewer = new SceneViewer();
			addChildAt(sceneViewer, 0);

			//sceneViewer.showScene(new LogoScene());
			sceneViewer.showScene(new InstructionsScene());
			//sceneViewer.showScene(new GameScene());

			redrawWidth();
			redrawHeight();
		}

		public function deactivate():void {
		}
	}
}
