package com.zehfernando.ld27.display.scenes.game.actors {
	import com.zehfernando.ld27.starling.templates.ShapeSprite;
	import com.zehfernando.utils.console.error;

	/**
	 * @author zeh fernando
	 */
	public class Background extends Actor {

		// Assets
		[Embed(source="/../embed/sprites.swf", symbol="BackgroundSky")]
		public static const SPRITE_BACKGROUND_SKY:Class;

		// Properties
		private var type:String;
		private var width:Number;
		private var height:Number;

		// Instances
		private var sprite:ShapeSprite;

		// ================================================================================================================
		// CONSTRUCTOR ----------------------------------------------------------------------------------------------------

		public function Background(__type:String, __width:Number, __height:Number) {
			super();

			type = __type;
			width = __width;
			height = __height;
		}


		// ================================================================================================================
		// PUBLIC INTERFACE -----------------------------------------------------------------------------------------------
		override public function start():void {
			super.start();

			var _class:Class = null;

			switch (type) {
				case "sky":
					_class = SPRITE_BACKGROUND_SKY;
					break;
			}

			if (_class == null) {
				error("Could not create a background of type ["+type+"]!!!");
				return;
			}

			sprite = new ShapeSprite(_class);
			sprite.width = width;
			sprite.height = height;
			worldModel.getWorldView().getBackgroundContainer().addChild(sprite);
		}

		override public function stop():void {
			super.stop();

			worldModel.getWorldView().getBackgroundContainer().removeChild(sprite);
			sprite.dispose();
			sprite = null;
		}
	}
}
