package com.zehfernando.ld27.display.scenes.game.actors.particles {
	import nape.geom.Vec2;

	import com.zehfernando.utils.RandomGenerator;

	/**
	 * @author zeh fernando
	 */
	public class ThrustParticle extends Particle {

		// Assets
		[Embed(source="/../embed/sprites.swf", symbol="ParticleSmoke1")]
		public static const SPRITE_SMOKE_1:Class;

		[Embed(source="/../embed/sprites.swf", symbol="ParticleSmoke2")]
		public static const SPRITE_SMOKE_2:Class;

		[Embed(source="/../embed/sprites.swf", symbol="ParticleSmoke3")]
		public static const SPRITE_SMOKE_3:Class;

		[Embed(source="/../embed/sprites.swf", symbol="ParticleSmoke4")]
		public static const SPRITE_SMOKE_4:Class;

		// ================================================================================================================
		// CONSTRUCTOR ----------------------------------------------------------------------------------------------------

		public function ThrustParticle(__x:Number, __y:Number, __velocity:Vec2) {
			super(__x, __y, __velocity);

			radius = 10;
			timeToLive = 0.5;
			blurRadius = 4;
			spriteShape = RandomGenerator.getFromArray([SPRITE_SMOKE_1, SPRITE_SMOKE_2, SPRITE_SMOKE_3, SPRITE_SMOKE_4]);

			rotationStart = RandomGenerator.getInRange(-0.1, 0.1);
			rotationEnd = RandomGenerator.getInRange(-0.1, 0.1);
			alphaStart = 0.5;
			alphaEnd = 0;
			scaleStart = 0.5;
			scaleEnd = RandomGenerator.getInRange(1.6, 2);
		}
	}
}
