package com.zehfernando.ld27.display.scenes.logo {
	import com.zehfernando.display.containers.DynamicDisplayAssetContainer;
	import com.zehfernando.ld27.display.scenes.LD27Scene;
	import com.zehfernando.ld27.display.scenes.instructions.InstructionsScene;
	import com.zehfernando.utils.DelayedCalls;

	import flash.display.Bitmap;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	/**
	 * @author zeh fernando
	 */
	public class LogoScene extends LD27Scene {

		// Assets
		[Embed(source="/../embed/logo.png")]
		public static const LOGO:Class;

		// Instances
		private var logoSprite:DynamicDisplayAssetContainer;
		private var logoBitmap:Bitmap;


		// ================================================================================================================
		// CONSTRUCTOR ----------------------------------------------------------------------------------------------------

		public function LogoScene() {
			super();

			// Visual assets
			logoBitmap = new LOGO();
			logoBitmap.smoothing = true;

			logoSprite = new DynamicDisplayAssetContainer();
			logoSprite.scaleMode = StageScaleMode.NO_SCALE;
			logoSprite.backgroundColor = 0x718c84;
			logoSprite.setAsset(logoBitmap);
			addChild(logoSprite);

			addEventListener(EVENT_FINISHED_SHOWING, onShown);
		}

		// ================================================================================================================
		// INTERNAL INTERFACE ---------------------------------------------------------------------------------------------

		override protected function redrawWidth():void {
			super.redrawWidth();
			logoSprite.width = _width;
		}

		override protected function redrawHeight():void {
			super.redrawHeight();
			logoSprite.height = _height;
		}

		private function showNextScene():void {
			getSceneViewer().showScene(new InstructionsScene());
		}


		// ================================================================================================================
		// EVENT INTERFACE ------------------------------------------------------------------------------------------------

		private function onShown(__e:Event):void {
			// Waits 2 seconds and start the game
			DelayedCalls.add(2000, showNextScene);
		}


		// ================================================================================================================
		// PUBLIC INTERFACE -----------------------------------------------------------------------------------------------

		override public function dispose():void {
			removeEventListener(EVENT_FINISHED_SHOWING, onShown);
			super.dispose();
		}

	}
}
